----------------------------
----------------------------
---- Playing Cards Code ----
------Opponent_AI.lua-------
----------------------------

Opponent_AI = {};
Opponent_AI.isAggressive = false;
Opponent_AI.isMultiples = false;
function Opponent_AI.OppPlayCards()

	print("Opponent_AI.OppPlayCards()");
	
	local cardTable		  	= nil;
	local tacticalCardTable = nil;
	local unplayableCards 	= {};
	local OppHand			= GLOBAL_VARS.Player2Store.hand;
	local OppHandIdx		= #GLOBAL_VARS.Player2Store.hand;
	local nonPlayableCards	= false;
	local cardPile			= GLOBAL_VARS.CardPile;
	local cardPileIdx		= #GLOBAL_VARS.CardPile;
	local cardsToBePlayed	= GLOBAL_VARS.CardsToBePlayed;
	
	if( cardPile[cardPileIdx] ~= 0 or
		cardPile[cardPileIdx].Attribute == nil or 		
		cardPile[cardPileIdx].Attribute == ATTRIBUTES.Reset )then
	--If the last card played is not a Special card
	--or is a 2	
		if( #GLOBAL_VARS.Player1Store.hand - OppHandIdx <= 4 or cardPileIdx < 15 ) then  
	--If the human player has 4 or less cards MORE than the AI,
	--or the number of card in card pile is less than 15,
	--then the Opp AI will play less aggressively as it has less
	--cards than the human and is therefore closer to winning,
	--and there is also no threat of having to pick up a large number of
	--cards.
			Opponent_AI.isAggressive = false;
			table.sort(OppHand, function(a,b) return a.number<b.number end);
	--This sorts the cards by their number, lowest to highest
	--The second argument is a small comparison function to 
	--customize the sorting.
			
			for i = 1, OppHand do 											
	--This checks the AI hand for any unplayable cards.
				if( OppHand[i].number < cardPile[cardPileIdx].number) then 
	--If a card is lower than the one last played then
	--it's unplayable 
					if( OppHand[i].Attribute ~= ATTRIBUTES.Reset or
						cardPile[cardPileIdx].Attribute ~= ATTRIBUTES.Go_Lower or
						OppHand[i].Attribute ~= ATTRIBUTES.Bundem or
						OppHand[i].Attribute ~= ATTRIBUTES.Mirror) then
	--Except for certain special cards.
						table.insert(unplayableCards, OppHand[i]);			
	--The unplayable cards are inserted into 'unplayableCards'.
						nonPlayableCards = true;
					end
				end
			end
			
			if( nonPlayableCards == true ) then								
	--Removes (temporarily) the unplayable cards
				RuleBook.RemoveHandCards(unplayableCards, OppHand);
				nonPlayableCards = false;
			end
			
			cardTable = Opponent_AI.MultipleCheck(OppHand);
			
	--Check for multiples and gets back card(s) to play which it feeds
	--into LastPickupCheck()
			
			if( #cardTable ~= 0 ) then									
	--If there are cards to play
				print("Playing Cards");
	
	--Perform a further tactical check
	--then remove left over entries from the hand.
	
				tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
				
				for i = 1, #tacticalCardTable do
					table.insert(cardsToBePlayed, tacticalCardTable[i]);
				end
					
				if( #unplayableCards > 0 ) then							
	--If there are any unplayable cards			
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do							
	--Insert them all back into the AI hand
						table.insert(OppHand, unplayableCards[i]);
					end		
				end
	--Play them
				RuleBook.PlayCards();
			else
	--If not call the pickup function
								
				if( #unplayableCards > 0 ) then							
	--If there are any unplayable cards			
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do							
	--Insert them all back into the AI hand
						table.insert(OppHand, unplayableCards[i]);
					end		
				end
				
				RuleBook.PickUp(GLOBAL_VARS.Player2Store);			

				print("Picking Up");
			end
		else
			table.sort(OppHand, function(a,b) return a.number>b.number end);
			Opponent_AI.isAggressive = true;
	--Sort from Highest to Lowest; play more aggressively
			
			for i = 1, OppHandIdx do 											
	--A repeat of the previous check
				if( OppHand[i].Attribute ~= ATTRIBUTES.Reset or
					cardPile[cardPileIdx].Attribute ~= ATTRIBUTES.Go_Lower or
					OppHand[i].Attribute ~= ATTRIBUTES.Bundem or
					OppHand[i].Attribute ~= ATTRIBUTES.Mirror) then
						table.insert(unplayableCards, OppHand[i]);
						nonPlayableCards = true;
				end
			end
			
			if( nonPlayableCards == true ) then
				RuleBook.RemoveHandCards(unplayableCards, OppHand);
				nonPlayableCards = false;
			end
			
			cardTable = Opponent_AI.MultipleCheck(OppHand); 				
	--Check for multiples
			
			if( #cardTable ~= 0 ) then
				print("Playing Cards");

				tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
				
				for i = 1, #tacticalCardTable do
					table.insert(cardsToBePlayed, tacticalCardTable[i]);
				end				
				if( #unplayableCards > 0 ) then
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do
						table.insert(OppHand, unplayableCards[i]);
					end
				end	
				RuleBook.PlayCards();
			else
				if( #unplayableCards > 0 ) then
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do
						table.insert(OppHand, unplayableCards[i]);
					end
				end				
				RuleBook.PickUp(GLOBAL_VARS.Player2Store);
				print("Picking Up");
			end
		end
	
	elseif( cardPile[cardPileIdx].Attribute == Queen ) then
	--If the last card was a Queen
		for i = 1, OppHandIdx do 	
	--Unplayability check
			if( OppHand[i].number < 11 or
				(OppHand[i].Attribute and 
				OppHand[i].Attribute ~= Queen) ) then	
	--If the card is lower than a Queen, 
	--or is a special card that is not a Queen
	--then it is unplayable
				table.insert(unplayableCards, OppHand[i]);													
		
				nonPlayableCards = true;																			
			end	
			
			if( nonPlayableCards == true ) then
				RuleBook.RemoveHandCards(unplayableCards, OppHand);
				nonPlayableCards = false;
			end
			
			cardTable = Opponent_AI.MultipleCheck(OppHand); 			
			
			if( #cardTable ~= 0 ) then
				print("Playing Cards");

				tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
				
				for i = 1, #tacticalCardTable do
					table.insert(cardsToBePlayed, tacticalCardTable[i]);
				end				
				if( #unplayableCards > 0 ) then
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do
						table.insert(OppHand, unplayableCards[i]);
					end
				end					
				RuleBook.PlayCards();
			else
				if( #unplayableCards > 0 ) then
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do
						table.insert(OppHand, unplayableCards[i]);
					end
				end				
				RuleBook.PickUp(GLOBAL_VARS.Player2Store);
				print("Picking Up");
			end
		end
	elseif( cardPile[cardPileIdx].Attribute == ATTRIBUTES.Go_Lower ) then						
	--If last card played was a Go Lower card
		
		for i = 1, OppHandIdx do
			if( OppHand[i].number > 7 or 
				OppHand[i].Attribute == ATTRIBUTES.Queen ) then														
	--If the card is greater than an 8 (Mirror, number:7) 
	--or its a special card that is not a reset, go lower,
	--or mirror then it is unplayable		
				table.insert(unplayableCards, OppHand[i]);													
		
				nonPlayableCards = true;
			end
			
			if( nonPlayableCards == true ) then
				RuleBook.RemoveHandCards(unplayableCards, OppHand);
				nonPlayableCards = false;
			end
			
			cardTable = Opponent_AI.MultipleCheck(OppHand); 			
			
			if( #cardTable ~= 0 ) then
				print("Playing Cards");
				
				tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
				
				for i = 1, #tacticalCardTable do
					table.insert(cardsToBePlayed, tacticalCardTable[i]);
				end
				
				if( #unplayableCards > 0 ) then
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do
						table.insert(OppHand, unplayableCards[i]);
					end
				end					
				RuleBook.PlayCards();
			else
				if( #unplayableCards > 0 ) then
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do
						table.insert(OppHand, unplayableCards[i]);
					end
				end				
				RuleBook.PickUp(GLOBAL_VARS.Player2Store);
				print("Picking Up");
			end																						
		end
	elseif( cardPile[cardPileIdx].Attribute == ATTRIBUTES.Mirror ) then							
	--If the last card played was a Mirror (8) card
		
		for i = 1, cardPileIdx do
			if( cardPile[cardPileIdx-1].Attribute == ATTRIBUTES.Go_Lower ) then					
	--If the card played before the 8 was a go lower card
	--then the AI must play by that rule
				for i = 1, OppHandIdx do																		
					if( OppHand[i].number > 7 ) then 
	--An 8 can be played, so any cards with			
	--a number greater than 7 (8 card) are 
	--unplayable.
						table.insert(unplayableCards, OppHand[i]);											
		
						nonPlayableCards = true;															
		
					end
			
					if( nonPlayableCards == true ) then
						RuleBook.RemoveHandCards(unplayableCards, OppHand);
						nonPlayableCards = false;
					end
					
					cardTable = Opponent_AI.MultipleCheck(OppHand); 			
					
					if( #cardTable ~= 0 ) then
						print("Playing Cards");

						tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
						
						for i = 1, #tacticalCardTable do
							table.insert(cardsToBePlayed, tacticalCardTable[i]);
						end						
						
						if( #unplayableCards > 0 ) then
							print("UnPlayable cards going back to hand");
							for i = 1, #unplayableCards do
								table.insert(OppHand, unplayableCards[i]);
							end
						end	
						RuleBook.PlayCards();
					else
						if( #unplayableCards > 0 ) then
							print("UnPlayable cards going back to hand");
							for i = 1, #unplayableCards do
								table.insert(OppHand, unplayableCards[i]);
							end
						end	
						RuleBook.PickUp(GLOBAL_VARS.Player2Store);
						print("Picking Up");
					end																						
				end
			else																							
	--Otherwise it only matters what the number of the
	--last card was. Anything lower than that card				
	--is unplayable, unless it is a reset card.	
				if( (OppHand[i].number < cardPile[cardPileIdx-1].number) and 
					OppHand[i].Attribute ~= ATTRIBUTES.Reset ) then			
				
					table.insert(unplayableCards, OppHand[i]);												
					nonPlayableCards = true;																			
				end
			
				if( nonPlayableCards == true ) then
					RuleBook.RemoveHandCards(unplayableCards, OppHand);
					nonPlayableCards = false;
				end
				
				cardTable = Opponent_AI.MultipleCheck(OppHand); 			
				
				if( #cardTable ~= 0 ) then
					print("Playing Cards");

					tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
					
					for i = 1, #tacticalCardTable do
						table.insert(cardsToBePlayed, tacticalCardTable[i]);
					end					
									
					cardTable = nil;
					
					if( #unplayableCards > 0 ) then
						print("UnPlayable cards going back to hand");
						for i = 1, #unplayableCards do
							table.insert(OppHand, unplayableCards[i]);
						end
					end	
					RuleBook.PlayCards();
				else
					if( #unplayableCards > 0 ) then
						print("UnPlayable cards going back to hand");
						for i = 1, #unplayableCards do
							table.insert(OppHand, unplayableCards[i]);
						end
					end	
					RuleBook.PickUp(GLOBAL_VARS.Player2Store);
					print("Picking Up");
				end
		
			end
		end
	elseif( cardPile[cardPileIdx] == 0 ) then
	--if the card pile is empty play anything. 
		cardTable = Opponent_AI.MultipleCheck(OppHand); 			
		
		if( #cardTable ~= 0 ) then
			print("Playing Cards");
			
			tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
			
			for i = 1, #tacticalCardTable do
				table.insert(cardsToBePlayed, tacticalCardTable[i]);
			end
			
			RuleBook.PlayCards();
		end
		
		cardTable = nil;
	end
end

function Opponent_AI.MultipleCheck(hand)
	--This function checks for multiples,
	--it also only returns playable cards
	print("Opponent_AI.MultipleCheck()");
	local cards 		  = {};
	local tempCard 		  = {}; 
	local multiples		  = false;
	
	table.insert(tempCard, hand[1]); 
	--Placing the first card in the hand in a temporary table.
		
	table.remove(hand, 1);			 
	
	for i = 1, 3 do 
	--For loop of 1 to 3. A limit of 3 because there can only be a maximum of
	--four cards of any kind, and one of those will have been sent to tempCard.
	
	--If there are two of the same type of card (ie, two 4s)
    --If the multiples aren't special cards	
    --take that card from 'hand' and put it into table 'cards'
    --multiples = true because multiples have been found
		if( hand[i].number == tempCard.number ) then 
			if( hand[i].Attribute == nil ) then 	 
				table.insert(cards, hand[i]);		 
				multiples = true;					 
				Opponent_AI.isMultiples = true;
			elseif( hand[i].Attribute and (hand[i].Attribute ~= ATTRIBUTES.Bundem and hand[i].Attribute ~= ATTRIBUTES.Queen) ) then 
	--if the card is special, but not a 10 or a queen
	--ignore multiples
				table.insert(cards, tempCard);		 
				tempCard.number = nil;
				tempCard.Attribute = nil;
				tempCard = nil;
	-- if the card is a 10
	-- if there are 3 or less cards in the hand			
	-- play all multiples			
	-- multiples = true because multiples have been found				
	-- otherwise			
	-- carry on as normal, ignoring multiples as it is not good tactics to play them.			
	
			elseif( hand[i].Attribute == ATTRIBUTES.Bundem) then 
				if( #hand <= 3) then			  	  
					table.insert(cards, hand[i]);	  
					multiples = true;	
					Opponent_AI.isMultiples = true;
				else								  
					table.insert(cards, tempCard);	  
					tempCard.number = nil;
					tempCard.Attribute = nil;
					tempCard = nil;	
				end
	-- if the card is a queen
	-- play all multiples
	-- multiples = true because multiples have been found
			elseif( hand[i].Attribute == Queen ) then 
				table.insert(cards, hand[i]);		  
				multiples = true;	
				Opponent_AI.isMultiples = true;
			end					
		else	
	--there are no multiples
	--carry on as normal
			table.insert(cards, tempCard);			  
			tempCard.number = nil;
			tempCard.Attribute = nil;
			tempCard = nil;
		end
	end
	--if there are multiples
	--removes them from the 'hand' table.
	if( multiples == true ) then	
		for i = 1, #cards do
			table.remove(hand, i);	
		end
		
	--resetting
		multiples 	= false;
		count 		= nil;
	end
	
	--Further variable resetting
	table.insert(cards, tempCard);
	tempCard.number = nil;
	tempCard.Attribute = nil;
	tempCard = nil;
	
	return cards; 
	--return card(s) to play
end

function Opponent_AI.LastPickupCheck(hand)
	print("Opponent_AI.LastPickupCheck()");
	--This functions comes after the multiple check
	--and adds another level of tactical analysis to
	--the A.I choosing his hand.
	
	local isReset		= false;
	local isMagic		= false;
	local isQueen		= false;
	local isBundem		= false;
	local isGoLower		= false;
	local isMirror 		= false;
	local hasQueen		= false;
	local hasGoLower	= false;
	local grtrThanSeven	= false;
	local magic			= 0;
	local reset			= 0;
	local queen			= 0;
	local burn			= 0;
	local goLower		= 0;
	local mirror		= 0;
	local oppQueen		= 0;
	local lowCards		= 0;
	local highCards		= 0;
	
	local card			= {};
	local tempCard		= {};
	local lastPickup	= {};
	
	
	if( GLOBAL_VARS.LastPickupName == GLOBAL_VARS.Player2Store.name or Opponent_AI.isMultiples == true ) then
	--Resetting Variables
		Opponent_AI.isAggressive = false; 
		Opponent_AI.isMultiples = false;
		return hand;
	
	--If the AI picked up last then it can't read anything
	--from the information and exits the function, or if there are
	--multiples to be played, play them instead.
	else
	--Otherwise it can check the cards.
		RuleBook.RemoveHandCards(GLOBAL_VARS.CardPile, lastPickup);
		--Re-using a function for a separate purpose. The LastPickup table is pruned
		--of cards that have since been replayed. Allowing it to react more accurately
		for i = 1, #lastPickup do
			if( lastPickup[i].Attribute == ATTRIBUTES.Reset ) then
				isMagic = true;
				isReset = true;
				reset = reset + 1;
				magic = magic + 1;
			elseif( lastPickup[i].Attribute == ATTRIBUTES.Go_Lower ) then
				isMagic = true;
				isGoLower = true;
				goLower = goLower + 1;
				magic = magic + 1;
			elseif( lastPickup[i].Attribute == ATTRIBUTES.Mirror ) then
				isMagic = true;
				isMirror = true;
				mirror = mirror + 1;
				magic = magic + 1;
			elseif( lastPickup[i].Attribute == ATTRIBUTES.Bundem ) then
				isMagic = true;
				isBundem = true; 
				bundem = bundem + 1;
				magic = magic + 1;
			elseif( lastPickup[i].Attribute == ATTRIBUTES.Queen ) then
				isMagic = true;
				isQueen = true;
				oppQueen = oppQueen + 1;
				magic = magic + 1;
			elseif( lastPickup[i].number < 6 ) then
	--if the card is less than a 7
				lowCards = lowCards + 1;
			elseif( lastPickup[i].number > 5 ) then
	--if the card is greater than a 6
				highCards = highCards + 1;
			end
		end	
	end
	
	local lowMinusHigh = lowCards - highCards;
	local highMinuslow = highCards - lowCards;
	local goLowerCard = 0;
	--checks for a go lower card;
	
	for i = 1, #hand do
		if( hand[i].Attribute == ATTRIBUTES.Go_Lower ) then
			hasGoLower = true;
			goLowerCard = i;
		end
	end
	
	if( isMagic == true ) then
		if( (isBundem == true and isMirror == true and isGoLower == true) or
			goLower >= 3 or bundem >= 3 or mirror >= 3 or
			oppQueen >= 3 or magic > 3) then
	-- If there are at least 3 magic cards in the last pickup of varying sorts
		
			if( Opponent_AI.isAggressive == true ) then
				for i = 1, #hand do
					if( hand[i].Attribute == Queen ) then
						hasQueen = true;
						queen = i;
	-- If the AI is aggressive and has a queen
	-- set hasQueen to true and equate queen to i
					end
					
					if( hand[i].number > 6 ) then
	-- If the card is greater than a 7 (number 6)
						table.insert(card, hand[i]);
						grtrThanSeven = true;
					end
					
					if( grtrThanSeven == true ) then
						if( hasQueen == true ) then
							Opponent_AI.isAggressive = false;
							Opponent_AI.isMultiples = false;						
							return hand[queen];
	--If the hand has a queen
	--play it, else look for
	--the first card higher 
	--than 7 else return hand	
						else
							Opponent_AI.isAggressive = false;
							Opponent_AI.isMultiples = false;						
							return card[1];
						end
					else
						return hand;
					end
				end
			else
	--If AI is not aggressive return hand unmodified.
				return hand;
			end
		elseif( isQueen == true and (#GLOBAL_VARS.Player1Store.hand < 5 or oppQueen > 1) ) then
	--If the opponent has a queen and either the human player is down 
	--to there last cards or there was more than one queen in the 
	--last pickup.
	--And the AI is aggressive
			if( Opponent_AI.isAggressive == true ) then			
				for i = 1, #hand do
					if( hand[i].number > 11 ) then
	--Check the hand for cards greater than a queen and return 
	--the first.
						Opponent_AI.isAggressive = false;
						Opponent_AI.isMultiples = false;
						return hand[i];
					end
				end
			else
	--If AI is not aggressive then return hand unmodified.
				Opponent_AI.isAggressive = false;
				Opponent_AI.isMultiples = false;		
				return hand;
			end		
		elseif( lowCards < 3 or highMinuslow > 4) then
	--If player 1 has fewer than 3 low cards (below 7)
	--or the difference between the amount of high and
	--low cards is greater than 4
			if( hasGoLower == true ) then
	--and AI has a goLowerCard, and it's playable then play it.
				if( GLOBAL_VARS.CardPile[card].number < 6 ) then
					return hand[goLowerCard];
				else
					return hand;
				end
			end
		elseif( lowMinusHigh > 5 ) then
	--If player 1 has a lot more low cards
	--than high and the AI is aggressive 
	--find any card higher than an 8 and lower than
	--an ace (to conserve the most power number card)
	--and play it.
			if( isAggressive == true ) then
				for i = 1, #hand do
					if( magic > 2 and hasQueen == true ) then
						return hand[queen];
	--if the player has more than two magic cards
	--and AI has a queen
	--return a queen to try and make the 
	--opposing player pick up
					end
					if( hand[i].number > 7 and hand[i].number < 13) then
						return hand[i];
					end
				end
			end
		end		
	else
	--if isMagic isn't true then there's no tactical edge, return hand unmodified.
		Opponent_AI.isAggressive = false;
		Opponent_AI.isMultiples = false;
		return hand;
	end
end

function Opponent_AI.cardChange()
	print("Opponent_AI.cardChange()");
	--Allows the AI to change it's top reserve cards at the start of the game
	--It will look for the strongest cards to reserve for the end
	local hand = GLOBAL_VARS.Player2Store.hand;
	local topRsv = GLOBAL_VARS.Player2Store.TopResvCards;
	
	if( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.CARD_CHANGE ) then
		table.sort(hand, function(a,b) return a.number>b.number end );
		table.sort(topRsv, function(a,b) return a.number>b.number end );
		for i = #topRsv, 1, -1 do
			for j = #hand, 1, -1 do

				local rCard = topRsv[i]
				local hCard = hand[j]
				
				if( hCard.attribute and rCard.attribute == nil or
					hCard.number > rCard.number )then
                
					hand[i], topRsv[j] = rCard, hCard
				end
			end
		end
	end
--Iterating backwards by 1
--In a double for loop
--This helps avoid some of
--the more subtle errors that can
--occur when looking for cards cards.
end